; 68 bytes including rts
scicco_short:
	move.l	(a0),d7
	move.w	d0,d1
	mulu.w	d0,d1
	sub.w	d0,d1		; = (size-lastrow) * 2
	lea	(a0,d1.w*2),a1	; start of last row
	lea	(a1,d0.w*4),a2	; end of table
	move.l	a2,a6		; the operation value address
.tryAll
	cmp.l	a1,a6		; check end of last row
	beq.b	.startReached	; if end of last row reached, backwards (rts)
	tst.l	-(a6)		; test for preset
	bne.b	.tryAll		; if so, get on with next
.increase
;* debug - this code is just to make it much faster to get a result, use for testing
;	cmp.l	#10,(a6)	; max value to try for in one field
;	bne.b	.no
;	move.l	#$FFFFFFFF,(a6)	; without debug border it will try all values in a long
;.no
;* debug end
	addq.l	#1,(a6)		; increase testval (starts with $1 - tests all)
	bcs.b	.noSolution	; we tried ALL values (0-$FFFFFFFF) -> overflow, rts
	move.l	a6,-(sp)
	bsr.b	.tryAll		; if we are not the last, try with following vals
	move.l	(sp)+,a6
	move.l	a1,a3		; copy of end prev/start act
	move.l	a2,a4		; copy of end start
.sumAll
	move.l	a3,a5		; for end of row cmp
	subq	#4,a4		; one back
.sumRow
	move.l	(a4),d2		; first CANT be zero (we worked with it from start on!)
	move.l	-(a4),-(a3)
	beq.b	.increase	; at least one value in last row is zero -> cant be a solution
	add.l	d2,(a3)
	bcs.b	.increase	; we have overflow -> try next value here
	cmp.l	a4,a5
	bne.b	.sumRow
	cmp.l	a3,a0		; check for head reached
	bne.b	.sumAll
	cmp.l	(a3),d7		; found it?
	bne.b	.increase	; if not found -> try next value here
.startReached
.noSolution
	rts
